searchData={"items":[{"type":"behaviour","title":"BuildkiteTestCollector.CiEnv","doc":"A behaviour for representing CI environments.\n\nImplemented for each CI environment.","ref":"BuildkiteTestCollector.CiEnv.html"},{"type":"macro","title":"BuildkiteTestCollector.CiEnv.__using__/1","doc":"Implements defaults for the optional callbacks.","ref":"BuildkiteTestCollector.CiEnv.html#__using__/1"},{"type":"callback","title":"BuildkiteTestCollector.CiEnv.branch/0","doc":"The git branch or tag that is being tested","ref":"BuildkiteTestCollector.CiEnv.html#c:branch/0"},{"type":"callback","title":"BuildkiteTestCollector.CiEnv.ci/0","doc":"Returns the name of the environment snake_case","ref":"BuildkiteTestCollector.CiEnv.html#c:ci/0"},{"type":"callback","title":"BuildkiteTestCollector.CiEnv.collector/0","doc":"Name of test collector","ref":"BuildkiteTestCollector.CiEnv.html#c:collector/0"},{"type":"callback","title":"BuildkiteTestCollector.CiEnv.commit_sha/0","doc":"The git commit SHA for the code under test","ref":"BuildkiteTestCollector.CiEnv.html#c:commit_sha/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.detect_env/0","doc":"Detect if the current process is running in a supported CI environment.","ref":"BuildkiteTestCollector.CiEnv.html#detect_env/0"},{"type":"callback","title":"BuildkiteTestCollector.CiEnv.detected?/0","doc":"Returns true if the specified environment is present","ref":"BuildkiteTestCollector.CiEnv.html#c:detected?/0"},{"type":"callback","title":"BuildkiteTestCollector.CiEnv.job_id/0","doc":"A unique job ID","ref":"BuildkiteTestCollector.CiEnv.html#c:job_id/0"},{"type":"callback","title":"BuildkiteTestCollector.CiEnv.key/0","doc":"A unique identifier for this test run","ref":"BuildkiteTestCollector.CiEnv.html#c:key/0"},{"type":"callback","title":"BuildkiteTestCollector.CiEnv.message/0","doc":"Any additional message from the CI environment","ref":"BuildkiteTestCollector.CiEnv.html#c:message/0"},{"type":"callback","title":"BuildkiteTestCollector.CiEnv.number/0","doc":"A unique number for the run","ref":"BuildkiteTestCollector.CiEnv.html#c:number/0"},{"type":"callback","title":"BuildkiteTestCollector.CiEnv.url/0","doc":"The URL for more information about this run","ref":"BuildkiteTestCollector.CiEnv.html#c:url/0"},{"type":"callback","title":"BuildkiteTestCollector.CiEnv.version/0","doc":"Version of test collector","ref":"BuildkiteTestCollector.CiEnv.html#c:version/0"},{"type":"module","title":"BuildkiteTestCollector.CiEnv.Buildkite","doc":"Environment detection and configuration for Buildkite.","ref":"BuildkiteTestCollector.CiEnv.Buildkite.html"},{"type":"module","title":"BuildkiteTestCollector.CiEnv.CircleCi","doc":"Environment detection and configuration for Circle CI.","ref":"BuildkiteTestCollector.CiEnv.CircleCi.html"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.CircleCi.job_id/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.CircleCi.html#job_id/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.CircleCi.message/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.CircleCi.html#message/0"},{"type":"module","title":"BuildkiteTestCollector.CiEnv.Generic","doc":"Environment detection and configuration for a Generic CI environment","ref":"BuildkiteTestCollector.CiEnv.Generic.html"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.Generic.branch/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.Generic.html#branch/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.Generic.commit_sha/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.Generic.html#commit_sha/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.Generic.detected?/0","doc":"Returns true if the environment variable `CI` is set","ref":"BuildkiteTestCollector.CiEnv.Generic.html#detected?/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.Generic.job_id/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.Generic.html#job_id/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.Generic.message/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.Generic.html#message/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.Generic.number/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.Generic.html#number/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.Generic.url/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.Generic.html#url/0"},{"type":"module","title":"BuildkiteTestCollector.CiEnv.GithubActions","doc":"Environment detection and configuration for Github Actions.","ref":"BuildkiteTestCollector.CiEnv.GithubActions.html"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.GithubActions.job_id/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.GithubActions.html#job_id/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.GithubActions.message/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.GithubActions.html#message/0"},{"type":"module","title":"BuildkiteTestCollector.CiEnv.Local","doc":"Environment detection and configuration for a local environment","ref":"BuildkiteTestCollector.CiEnv.Local.html"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.Local.branch/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.Local.html#branch/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.Local.commit_sha/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.Local.html#commit_sha/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.Local.detected?/0","doc":"Returns true if the environment variable `BUILDKITE_TEST_ANALYTICS_LOCAL` is set","ref":"BuildkiteTestCollector.CiEnv.Local.html#detected?/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.Local.job_id/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.Local.html#job_id/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.Local.message/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.Local.html#message/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.Local.number/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.Local.html#number/0"},{"type":"function","title":"BuildkiteTestCollector.CiEnv.Local.url/0","doc":"","ref":"BuildkiteTestCollector.CiEnv.Local.html#url/0"},{"type":"module","title":"BuildkiteTestCollector.Duration","doc":"The difference between two instants with microsecond accuracy.\n\nThe Buildkite analytics API stores all times as decimal seconds since the\nstart of the test run.  Therefore we use `Duration` to calculate the span\nbetween two `Instant` values.","ref":"BuildkiteTestCollector.Duration.html"},{"type":"function","title":"BuildkiteTestCollector.Duration.abs/1","doc":"Return the absolute duration (ie make the duration unsigned).","ref":"BuildkiteTestCollector.Duration.html#abs/1"},{"type":"function","title":"BuildkiteTestCollector.Duration.as_seconds/1","doc":"The duration of the timing, in (fractional) seconds.","ref":"BuildkiteTestCollector.Duration.html#as_seconds/1"},{"type":"function","title":"BuildkiteTestCollector.Duration.between/2","doc":"Return the elapsed time between two instants.","ref":"BuildkiteTestCollector.Duration.html#between/2"},{"type":"function","title":"BuildkiteTestCollector.Duration.elapsed/1","doc":"Returns the elapsed duration between `instant` and now.","ref":"BuildkiteTestCollector.Duration.html#elapsed/1"},{"type":"function","title":"BuildkiteTestCollector.Duration.from_microseconds/1","doc":"Create a new duration directly from microseconds.","ref":"BuildkiteTestCollector.Duration.html#from_microseconds/1"},{"type":"function","title":"BuildkiteTestCollector.Duration.from_seconds/1","doc":"Create a new duration from the specified number of seconds.","ref":"BuildkiteTestCollector.Duration.html#from_seconds/1"},{"type":"type","title":"BuildkiteTestCollector.Duration.t/0","doc":"","ref":"BuildkiteTestCollector.Duration.html#t:t/0"},{"type":"module","title":"BuildkiteTestCollector.Formatter","doc":"Documentation for `BuildkiteTestCollectorFormatter`.\n\nSee instructions https://github.com/elixir-lang/elixir/blob/main/lib/ex_unit/lib/ex_unit/formatter.ex\n\nInspiration https://github.com/elixir-lang/elixir/blob/main/lib/ex_unit/lib/ex_unit/cli_formatter.ex","ref":"BuildkiteTestCollector.Formatter.html"},{"type":"function","title":"BuildkiteTestCollector.Formatter.add_span/2","doc":"Manually add a trace span to the currently running test.\n\nYou can add timing information about sql queries, http requests, etc to your\ntest analytics.\n\nIt's probably better to use the helpers in the `Tracing` module.","ref":"BuildkiteTestCollector.Formatter.html#add_span/2"},{"type":"function","title":"Example - BuildkiteTestCollector.Formatter.add_span/2","doc":"```elixir\nalias BuildkiteTestCollector.{Formatter, Instant}\n\ntest \"example of instrumenting a query\", tags do\n  start_at = Instant.now()\n\n  MyApp.Repo.all(my_complicated_query)\n\n  end_at = Instant.now()\n\n  Formatter.add_span(tags, %{\n    start_at: start_at,\n    end_at: end_at,\n    section: :sql,\n    detail: inspect(my_complicated_query)\n  })\nend\n```","ref":"BuildkiteTestCollector.Formatter.html#add_span/2-example"},{"type":"function","title":"BuildkiteTestCollector.Formatter.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"BuildkiteTestCollector.Formatter.html#child_spec/1"},{"type":"type","title":"BuildkiteTestCollector.Formatter.span_with_duration/0","doc":"A trace with a known duration.","ref":"BuildkiteTestCollector.Formatter.html#t:span_with_duration/0"},{"type":"type","title":"BuildkiteTestCollector.Formatter.span_with_start_and_end_at/0","doc":"A trace with known start and end time.","ref":"BuildkiteTestCollector.Formatter.html#t:span_with_start_and_end_at/0"},{"type":"type","title":"BuildkiteTestCollector.Formatter.tags/0","doc":"The ExUnit tags, (specifically `module` and `test` tags)","ref":"BuildkiteTestCollector.Formatter.html#t:tags/0"},{"type":"type","title":"BuildkiteTestCollector.Formatter.test_id/0","doc":"Unique identifier for tests.\n\nContains the module that the test is defined in, and the name of the test as an atom.","ref":"BuildkiteTestCollector.Formatter.html#t:test_id/0"},{"type":"module","title":"BuildkiteTestCollector.HttpTransport","doc":"Handles encoding and transmitting payloads to Buildkite's test analytics API\nvia HTTP.","ref":"BuildkiteTestCollector.HttpTransport.html"},{"type":"function","title":"BuildkiteTestCollector.HttpTransport.maybe_send_batch/1","doc":"If the payload contains at least the configured batch size (default 500) test\nresults, then send a batch to the API.","ref":"BuildkiteTestCollector.HttpTransport.html#maybe_send_batch/1"},{"type":"function","title":"BuildkiteTestCollector.HttpTransport.send/1","doc":"Send a `Payload` to Buildkite's test analytics API.","ref":"BuildkiteTestCollector.HttpTransport.html#send/1"},{"type":"module","title":"BuildkiteTestCollector.Instant","doc":"Represents a single instant with microsecond accuracy.\n\nWraps monotonic time to ensure that there are no unit mistakes.","ref":"BuildkiteTestCollector.Instant.html"},{"type":"module","title":"Why not just use `DateTime` instead? - BuildkiteTestCollector.Instant","doc":"Sadly, the wall clock time can move backwards and forwards between samples\n(for example if [NTP](https://www.ntp.org) is updating the clock, or during a\ndaylight savings transition).  The system monotonic clock always moves\nforwards, regardless of the current wall clock time.  This means it's no good\nfor measuring the absolute time, but is perfect for measuring relative time.\n\nSee\n[erlang:monotonic_time/0](https://www.erlang.org/doc/man/erlang.html#monotonic_time-0)\nfor more information.","ref":"BuildkiteTestCollector.Instant.html#module-why-not-just-use-datetime-instead"},{"type":"function","title":"BuildkiteTestCollector.Instant.add/2","doc":"Add a duration to an instant and return a new instant.","ref":"BuildkiteTestCollector.Instant.html#add/2"},{"type":"function","title":"BuildkiteTestCollector.Instant.now/0","doc":"Return an instant representing \"now\" as understood by the system's monotonic\nclock.","ref":"BuildkiteTestCollector.Instant.html#now/0"},{"type":"type","title":"BuildkiteTestCollector.Instant.t/0","doc":"","ref":"BuildkiteTestCollector.Instant.html#t:t/0"},{"type":"module","title":"BuildkiteTestCollector.Payload","doc":"A structure that represents all data about a test suite run needed for analytics.","ref":"BuildkiteTestCollector.Payload.html"},{"type":"function","title":"BuildkiteTestCollector.Payload.as_json/1","doc":"Convert the payload into a map ready for serialisation to JSON.\n\nThis is done as a separate step because all timings are relative to the\npayload start time, so must be calculated.","ref":"BuildkiteTestCollector.Payload.html#as_json/1"},{"type":"function","title":"BuildkiteTestCollector.Payload.init/1","doc":"Initialise an empty payload with the given CI environment.","ref":"BuildkiteTestCollector.Payload.html#init/1"},{"type":"function","title":"BuildkiteTestCollector.Payload.push_test_result/2","doc":"Push a test pesult into the payload.","ref":"BuildkiteTestCollector.Payload.html#push_test_result/2"},{"type":"type","title":"BuildkiteTestCollector.Payload.serialised_environment/0","doc":"","ref":"BuildkiteTestCollector.Payload.html#t:serialised_environment/0"},{"type":"function","title":"BuildkiteTestCollector.Payload.set_start_time/2","doc":"Set the start time of the suite.","ref":"BuildkiteTestCollector.Payload.html#set_start_time/2"},{"type":"type","title":"BuildkiteTestCollector.Payload.t/0","doc":"","ref":"BuildkiteTestCollector.Payload.html#t:t/0"},{"type":"module","title":"BuildkiteTestCollector.TestResult","doc":"Information about in individual test execution.\n\nContains the details needed to process the analytics for the test, such as\nsuccess/failure, failure reason, trace, etc.","ref":"BuildkiteTestCollector.TestResult.html"},{"type":"function","title":"BuildkiteTestCollector.TestResult.add_span/2","doc":"Add a tracing span to the test result history.","ref":"BuildkiteTestCollector.TestResult.html#add_span/2"},{"type":"function","title":"BuildkiteTestCollector.TestResult.as_json/2","doc":"Convert the test result into a map ready for serialisation to JSON.\n\n\nThis is done as a separate step because all timings are relative to the\npayload start time, so must be calculated.","ref":"BuildkiteTestCollector.TestResult.html#as_json/2"},{"type":"type","title":"BuildkiteTestCollector.TestResult.expanded_failure/0","doc":"More information about a test failure, if available","ref":"BuildkiteTestCollector.TestResult.html#t:expanded_failure/0"},{"type":"type","title":"BuildkiteTestCollector.TestResult.history/0","doc":"The test run timing and tracing","ref":"BuildkiteTestCollector.TestResult.html#t:history/0"},{"type":"function","title":"BuildkiteTestCollector.TestResult.new/2","doc":"Convert an `ExUnit.Test` into a Buildkite Test Analytics datum.","ref":"BuildkiteTestCollector.TestResult.html#new/2"},{"type":"type","title":"BuildkiteTestCollector.TestResult.span/0","doc":"A tracing span","ref":"BuildkiteTestCollector.TestResult.html#t:span/0"},{"type":"type","title":"BuildkiteTestCollector.TestResult.t/0","doc":"Individual test summary.  Spec as yet unconfirmed.","ref":"BuildkiteTestCollector.TestResult.html#t:t/0"},{"type":"module","title":"BuildkiteTestCollector.Tracing","doc":"Helpers for doing simple tracing in your tests.","ref":"BuildkiteTestCollector.Tracing.html"},{"type":"function","title":"BuildkiteTestCollector.Tracing.measure/4","doc":"Measure the execution time of a function and add a trace to the test analytics.","ref":"BuildkiteTestCollector.Tracing.html#measure/4"},{"type":"function","title":"Example - BuildkiteTestCollector.Tracing.measure/4","doc":"```elixir\nalias BuildkiteTestCollector.Tracing\n\ntest \"it can measure an HTTP request\", tags do\n  assert {:ok, _} =\n           Tracing.measure(tags, :http, \"The koan of Github\", fn ->\n             Tesla.get(\"https://api.github.com/zen\", headers: [{\"user-agent\", \"Tesla\"}])\n           end)\nend\n\n\ntest \"it can measure a SQL query\", tags do\n  import Ecto.Query\n\n  query =\n    from(tt in \"time_travellers\",\n      where: tt.born >= 1968 and tt.born <= 1970,\n      select: tt.name,\n      order_by: tt.name\n    )\n\n  assert {:ok, [\"Marty McFly\", \"Theodore Logan, III\", \"William Stanley Preston, Esq.\"]} =\n           Tracing.measure(tags, :sql, inspect(query), fn ->\n             MyApp.all(query)\n           end)\nend\n```","ref":"BuildkiteTestCollector.Tracing.html#measure/4-example"},{"type":"type","title":"BuildkiteTestCollector.Tracing.section/0","doc":"Valid trace types.\n\nSee [the documentation][1] for more information.\n\n[1]: https://buildkite.com/docs/test-analytics/importing-json#json-test-results-data-reference-span-objects","ref":"BuildkiteTestCollector.Tracing.html#t:section/0"},{"type":"type","title":"BuildkiteTestCollector.Tracing.tags/0","doc":"ExUnit test tags (specifically the `module` and `test` tags).\n\nThese are used to uniquely identify the test being executed.","ref":"BuildkiteTestCollector.Tracing.html#t:tags/0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}